import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class BatchInsertUsingJDBCPreparedStatement {

	public static void main(String[] args) {

		// variables
		Connection connection = null;
		PreparedStatement preparedStatement = null;

		// Step 1: Loading or registering MySQL JDBC driver class
		try {
			Class.forName("com.mysql.jdbc.Driver");
		}
		catch(ClassNotFoundException cnfex) {
			System.out.println("Problem in loading or registering MySQL JDBC driver");
			cnfex.printStackTrace();
		}

		// Step 2: Opening database connection
		try {

			// Step 2.A: Create and get connection using DriverManager class
			connection = DriverManager.getConnection("jdbc:mysql://localhost:3306/PLAYER_INFO", "root", "root@123"); 

			// Start of JDBC transaction
			connection.setAutoCommit(false);

			// create SQL query to insert PLAYER info
			String sqlInsertQuery = "INSERT INTO PLAYER (NAME, AGE, MATCHES) VALUES (?, ?, ?)";

			// Step 2.B: Creating JDBC Statement 
			preparedStatement = connection.prepareStatement(sqlInsertQuery);

			// new 1st PLAYER info insert
			preparedStatement.setString(1, "Jacques Kallis");
			preparedStatement.setInt(2, 40);
			preparedStatement.setInt(3, 166);
			preparedStatement.addBatch();

			// new 2nd PLAYER info insert
			preparedStatement.setString(1, "Saqlain Mushtaq");
			preparedStatement.setInt(2, 39);
			preparedStatement.setInt(3, 49);
			preparedStatement.addBatch();

			// new 3rd PLAYER info insert
			preparedStatement.setString(1, "Saeed Ajmal");
			preparedStatement.setInt(2, 38);
			preparedStatement.setInt(3, 33);
			preparedStatement.addBatch();

			// Step 2.C: Executing SQL & retrieve data into ResultSet
			preparedStatement.executeBatch();

			// End of JDBC transaction
			connection.commit();

			System.out.println("All new PLAYER info insertion is successfull using JDBC PreparedStatement Interface");
		}
		catch(SQLException sqlex){
			sqlex.printStackTrace();
		}
		finally {

			// Step 3: Closing database connection
			try {
				if(null != connection) {

					// cleanup resources, once after processing
					preparedStatement.close();

					// and then finally close connection
					connection.close();
				}
			}
			catch (SQLException sqlex) {
				sqlex.printStackTrace();
			}
		}
	}
}